/* PSMTP̎O`FbN       */
/*   Copyright(C)2018 by T.Toda */
#define	BUFSIZE	1024
#include <stdio.h>

static int	divaddr(void), pickhead(int), cmphead(char *, char *);
static void	pickadr(char *);
static FILE	*fp;
static char	buffer[BUFSIZE];

int	main(int argc, char **argv, char **envp)
{
	int	c = 0;
	int	ided = 0, dated = 0, fromed = 0, subjected = 0, typed = 0;

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile]\n", stderr);
		return	4;
	}
	if( argc != 2 ){
		fp = stdin;
	}
	else if(( fp = fopen(argv[1],"r")) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[1],stderr);
		fputs("'.\n",stderr);
		return	8;
	}

	for(;;){
		if( pickhead(c) ){
			if( cmphead("Message-ID:" ,buffer) ){
				ided++;
			}
			if( cmphead("Date:" ,buffer) ){
				dated++;
			}
			if( cmphead("From:" ,buffer) ){
				fromed++;
			}
			if( cmphead("Subject:" ,buffer) ){
				subjected++;
			}
			if( cmphead("Content-Type:" ,buffer) ){
				typed++;
			}
			if( cmphead("To:", buffer) ||
			    cmphead("Cc:", buffer) ||
			    cmphead("Bcc:", buffer) ){
				c = divaddr();
			}
			else{
				do{
					c = getc(fp);
				}while( (c != '\n') && ( c != EOF ) );
				c = getc(fp);
			}
		}
		else{
			c = getc(fp);
		}
		if( (c == '\n') || ( c == EOF ) ){
			if( ided ){
				fputs("**** Remaining Message-Id: ****\n", stderr);
			}
			if( dated ){
				fputs("**** Remaining Date: ****\n", stderr);
			}
			if( fromed ){
				fputs("**** Remaining From: ****\n", stderr);
			}
			if( subjected == 0 ){
				fputs("**** No Subject: ****\n", stderr);
			}
			if( subjected > 1 ){
				fputs("**** Dual Subject: ****\n", stderr);
			}
			if( typed == 0 ){
				fputs("**** No Content-Type: ****\n", stderr);
			}
			if( typed > 1 ){
				fputs("**** Dual Content-Type: ****\n", stderr);
			}
			return	0;
		}
	}
}

static int	pickhead(int c0)
{
	int	c, i;

	if( c0 ){
		buffer[0] = c0;
		i = 1;
	}
	else{
		i = 0;
	}

	for(;; i++ ){
		c = getc(fp);
		if( (c == '\n') || (c == EOF) || (i > BUFSIZE - 2) ){
			return	0;
		}
		buffer[i] = c;
		if( c == ':' ){
			if( getc(fp) == ' ' ){
				buffer[i + 1] = 0;
				return	1;
			}
			while( (c != '\n') && (c != EOF) ){
				c = getc(fp);
			}
			return	0;
		}
	}
}

static int	cmphead(char *head, char *line)
{
	while( *head ){
		if( ((*head) | 0x70) != ((*line) | 0x70) ){
			return	0;
		}
		head++;
		line++;
	}
	return	1;
}

static int	divaddr()
{
	char	buffer[BUFSIZE + 2];
	int	c, i = 0;

	for(;;){
		c = getc(fp);
		if( c == EOF ){
			break;
		}
		if( c == '\n' ){
			c = getc(fp);
			if( (c == ' ') || (c == '\t') ){
				continue;
			}
			break;
		}
		if( c == ',' ){
			buffer[i] = 0;
			pickadr(buffer);
			i = 0;
		}
		else{
			buffer[i] = c;
			if( i < BUFSIZE ){
				i++;
			}
		}
	}

	buffer[i] = 0;
	pickadr(buffer);
	return	c;
}

static void	pickadr(char *s)
{
	int	i, i1, i2, p1, p2;

	for( i1 = 0 ; (s[i1] == ' ') || (s[i1] == '\t') ; i1++ ){
	}
	for( i2 = i1 ; s[i2] ; i2++ ){
	}
	while( (s[i2 - 1] == ' ') || (s[i2 - 1] == '\t') ){
		i2--;
	}
	for( p1 = i1 ; p1 < i2 ; p1++ ){
		if( s[p1] == '<' ){
			p1++;
			break;
		}
	}
	for( p2 = i2 ; p2 >= i1 ; p2-- ){
		if( s[p2] == '>' ){
			break;
		}
	}
	if( p1 > p2 ){
		p1 = i1;
		p2 = i2;
	}
	for( i = p1 ; i < p2 ; i++ ){
		putchar(s[i]);
	}
	putchar('\n');
}
